#include "Windows.h"

#ifndef EXPORTS
#ifdef  __cplusplus
#define EXPORTS extern "C" __declspec (dllimport)
#else
#define EXPORTS __declspec (dllimport)
#endif 
#endif

#ifndef __PCIE_LM4_HEADER__
#define __PCIE_LM4_HEADER__


#define MAX_BOARD_NUMBER 32
#define MAX_EVENT_NUMBER 20


#define JTMPCIE   0x687701C4 
#define PCIELM4   0x357701C4 

// Return code
#define PCIELM4_NoErr                        0 //Correct
#define PCIELM4_OpenDriverErr                1 //Open driver error
#define PCIELM4_PnPDriverErr				 2 //Plug & Play error
#define PCIELM4_DriverNoOpen                 3 //The driver was not open
#define PCIELM4_GetDriverVersionErr          4 //Receive driver version error
#define PCIELM4_ExceedBoardNumber		     5 //Board number error
#define PCIELM4_FindBoardErr				 6 //No board found
#define PCIELM4_BoardMappingErr			     7 //Board Mapping error
#define PCIELM4_DIOModesErr					 8 //Digital input/output mode setting error
#define PCIELM4_InvalidAddress				 9 //Invalid address
#define PCIELM4_InvalidSize					10 //Invalid size
#define	PCIELM4_InvalidPortNumber			11 //Invalid port number
#define PCIELM4_UnSupportedModel			12 //This board model is not supported
#define PCIELM4_UnSupportedFun				13 //This function is not supported
#define PCIELM4_InvalidChannelNumber		14 //Invalid channel number
#define PCIELM4_InvalidValue				15 //Invalid value
#define PCIELM4_InvalidMode					16 //Invalid mode
#define PCIELM4_GetAIStatusTimeOut			17 //A timeout occurred while receiving the status of the analog input
#define PCIELM4_TimeOutErr					18 //Timeout error
#define PCIELM4_CfgCodeIndexErr			    19 //A compatible configuration code table index could not be found
#define PCIELM4_ADCCTLTimeoutErr			20 //ADC controller a timeout error
#define PCIELM4_FindPCIIndexErr			21 //A compatible PCI table index value could not be found
#define PCIELM4_InvalidSetting				22 //Invalid setting value
#define PCIELM4_AllocateMemErr	    		23 //Error while allocating the memory space
#define PCIELM4_InstallEventErr			24 //Error while installing the interrupt event
#define PCIELM4_InstallIrqErr				25 //Error while installing the interrupt IRQ
#define PCIELM4_RemoveIrqErr				26 //Error while removing the interrupt IRQ
#define PCIELM4_ClearIntCountErr			27 //Error while the clear interrupt count
#define PCIELM4_GetSysBufferErr			28 //Error while retrieving the system buffer
#define PCIELM4_CreateEventErr				29 //Error while create the event
#define PCIELM4_UnSupportedResolution		30 //Resolution not supported
#define PCIELM4_UnSupportRate 			31 //Sampling Rate not spported
#define PCIELM4_ThreadTimeOutErr			32 //Thread timeout error
#define PCIELM4_FIFOOverFlowErr			33 //FIFO overflow error
#define PCIELM4_FIFOTimeOutErr				34 //FIFO timeout error
#define PCIELM4_GetIntInstStatus			35 //Retrieves the status of the interrupt installation
#define PCIELM4_GetBufStatus				36 //Retrieves the status of the system buffer
#define PCIELM4_SetBufCountErr			    37 //Error while setting the buffer count
#define PCIELM4_SetBufInfoErr              38 //Error while setting the buffer data
#define PCIELM4_FindCardIDErr				39 //Card ID code could not be found
#define PCIELM4_EventThreadErr				40 //Event Thread error
#define PCIELM4_AutoCreateEventErr			41 //Error while automatically creating an event
#define PCIELM4_RegThreadErr				42 //Register Thread error
#define PCIELM4_SearchEventErr				43 //Search Event error
#define PCIELM4_FifoResetErr				44 //Error while resetting the FIFO
#define PCIELM4_InvalidBlock				45 //Invalid EEPROM block
#define PCIELM4_InvalidAddr				46 //Invalid EEPROM address
#define PCIELM4_AcqireSpinLock				47 //Error while acquiring spin lock
#define PCIELM4_ReleaseSpinLock			48 //Error while releasing spin lock
#define	PCIELM4_SetControlErr				49 //Analog input setting error
#define PCIELM4_InvalidChannels			50 //Invalid channel number
#define PCIELM4_SearchCardErr				51 //Invalid model number
#define PCIELM4_SetMapAddressErr			52 //Error while setting the mapping address
#define PCIELM4_ReleaseMapAddressErr		53 //Error while releasing the mapping address
#define PCIELM4_InvalidOffset				54 //Invalid memory offset
#define PCIELM4_ShareHandleErr				55 //Open the share memory fail
#define PCIELM4_InvalidDataCount			56 //Invalid data count
#define PCIELM4_WriteEEPErr				57 //Error while writing the EEPROM
#define PCIELM4_CardIOErr                  58 //CardIO error
#define PCIELM4_IOErr                      59 //MemoryIO error
#define PCIELM4_SetScanChannelErr			60 //Set channel scan number error
#define PCIELM4_SetScanConfigErr           61 //Set channel scan config error
#define PCIELM4_GetMMIOMapStatus			62 //Get MMIO Status error
#define PCIELM4_InvalidEEPCmd				63 //Invalid EEPROM Command
#define PCIELM4_CheckEEPCRCErr				64 //Check EEPROM CRC error
#define PCIELM4_CtlEEPFail					65 //Control EEPROM fail
#define PCIELM4_UnknownEEPErr				66 //Unknown Error on EEPROM
#define PCIELM4_SetAIMuxErr                 67 //
#define PCIELM4_SetAICONErr                 68
#define PCIELM4_SetAIRATEErr                69
#define PCIELM4_WriteAOBufErr               70
#define PCIELM4_TimeOut1Err					71 //Timeout error
#define PCIELM4_TimeOut2Err					72 //Timeout error
#define PCIELM4_TimeOut3Err					73 //Timeout error
#define PCIELM4_TimeOut4Err					74 //Timeout error
#define PCIELM4_TimeOut5Err					75 //Timeout error
#define PCIELM4_TimeOut6Err					76 //Timeout error
#define PCIELM4_SetAIUnknowErr              77 


//User AO Config Code for Voltage
#define PCIELM4_AO_UNI_5V		 0	//0  ~  5V
#define PCIELM4_AO_UNI_10V		 1	//0  ~ 10V
#define PCIELM4_AO_BI_5V		 2	//+/-   5V
#define PCIELM4_AO_BI_10V       3  //+/-  10V

#define MAX_AICFGCODE_NUMBER 24//User definition the total number of the AI ConfigCodeTotal


//AI Mode
#define PCIELM4_AIMODE_POLLING 0

#define PCIELM4_AICFG_AUTOZERO 1
#define PCIELM4_AICFG_BUFFON   2



//User Config Code

#define PCIELM4_AI_BI_10V		 0	//Bipolar +/- 10V
#define PCIELM4_AI_BI_5V		 1	//Bipolar +/-  5V
#define PCIELM4_AI_BI_2V5		 2	//Bipolar +/-  2.5V
#define PCIELM4_AI_BI_1V25	     3	//Bipolar +/-  1.25V
#define PCIELM4_AI_BI_227MV	     0	//Bipolar +/-  227mV

//AI sample Rate
#define PCIELM4_AIRATE_15000 15000
#define PCIELM4_AIRATE_7500   7500
#define PCIELM4_AIRATE_3750   3750
#define PCIELM4_AIRATE_1000   1000
#define PCIELM4_AIRATE_500     500
#define PCIELM4_AIRATE_30       30
#define PCIELM4_AIRATE_15       15

typedef struct _PCIELM4_DEVICE_INFO_
{
	DWORD dwSize;			//Structure Size
	
	WORD wVendorID;			//Vendor ID
	WORD wDeviceID;			//Device ID
	
	WORD wSubVendorID;		//Sub Vendor ID
	WORD wSubDeviceID;		//Sub Device ID
	
	DWORD dwBAR[6];			//PCI Bar 0 ~ 5
	
	UCHAR BusNo;			//the PCI Bus No. in mainboard
	UCHAR DevNo;			//the Slot No. in PCI bus
	UCHAR IRQ;				//IRQ No.
	UCHAR Aux;				//Sub Aux for Tiger series,0xFF=N/A
	
	ULONGLONG dwBarVirtualAddress[6];   //PCI Bar Virtual Address(For MMIO)
	
}PCIELM4_DEVICE_INFO,*PPCIELM4_DEVICE_INFO;

//extern PCIELM4_DEVICE_INFO DevInfo[MAX_BOARD_NUMBER];

typedef struct _PCIELM4_CARD_INFO_
{
	DWORD dwSize;			//Structure size
	DWORD dwModelNo;		//Model Number
	
	//CardID is update when calling the function each time.
    UCHAR CardID;			//for new cards, 0xFF=N/A
	UCHAR wSingleEnded;		//for new cards,1:S.E 2:D.I.F,0xFF=N/A
	WORD wAIOResolution;	//AI/AO Resolution High byte is AI, Low byte is AO
	
	WORD wAIChannels;		//Number of AI channels(AD)
	WORD wAOChannels;		//Number of AO channels(DA)
	
	WORD wDIPorts;			//Number of DI ports
	WORD wDOPorts;			//Number of DO ports
	
	WORD wDIOPorts;			//Number of DIO ports
	WORD wDIOPortWidth;		//The width is 8/16/32 bit.
	
	WORD wCounterChannels;	//Number of Timers/Counters
	WORD wMemorySize;		//PCI-M512==>512, Units in KB.
	
	DWORD dwReserved1[6];   //Reserver 
	
}PCIELM4_CARD_INFO,*PPCIELM4_CARD_INFO;

EXPORTS WORD  CALLBACK  PCIELM4_GetDllVersion(DWORD *dwDLLVer);

EXPORTS WORD  CALLBACK  PCIELM4_DriverInit(WORD *wTotalBoards);
EXPORTS WORD  CALLBACK  PCIELM4_DriverClose(void);
EXPORTS WORD  CALLBACK  PCIELM4_GetCardInfo(WORD wBoardNo, PPCIELM4_DEVICE_INFO sDevInfo, PPCIELM4_CARD_INFO sCardInfo,char* szModelName);
EXPORTS WORD  CALLBACK	PCIELM4_ReadPort(DWORD dwAddress,WORD wSize,DWORD* dwVal);				  
EXPORTS WORD  CALLBACK	PCIELM4_WritePort(DWORD dwAddress,WORD wSize,DWORD  dwVal);				  
EXPORTS WORD  CALLBACK	PCIELM4_ReadPort32(DWORD dwAddress,DWORD* dwLow,DWORD* dwHigh);				  
EXPORTS WORD  CALLBACK	PCIELM4_WritePort32(DWORD dwAddress,DWORD dwLow,DWORD  dwHigh);
EXPORTS WORD  CALLBACK	PCIELM4_WritePhyMemory(ULONGLONG dwAddress,WORD wSize,DWORD dwValue);
EXPORTS WORD  CALLBACK	PCIELM4_ReadPhyMemory(ULONGLONG dwAddress,WORD wSize,DWORD* dwValue);
EXPORTS WORD  CALLBACK	PCIELM4_WritePhyMemory16(ULONGLONG dwAddress,DWORD dwValueLW,DWORD dwValueHW);
EXPORTS WORD  CALLBACK	PCIELM4_ReadPhyMemory16(ULONGLONG dwAddress,DWORD* dwValueLW,DWORD* dwValueHW);
EXPORTS WORD  CALLBACK	PCIELM4_ReadPhyMemory64(ULONGLONG dwAddress,DWORD* dwValue);

//Digital I/O function
EXPORTS WORD  CALLBACK  PCIELM4_WriteDO(WORD wBoardNo, DWORD dwDOValue);
EXPORTS WORD  CALLBACK  PCIELM4_ReadDI(WORD wBoardNo, DWORD* dwDIValue);

//Analog Output
EXPORTS WORD  CALLBACK  PCIELM4_ConfigAO(WORD wBoardNo,WORD wChannel, WORD wMode, WORD wAORange);
EXPORTS WORD  CALLBACK  PCIELM4_WriteAOVoltage(WORD wBoardNo,WORD wChannel, float fAOValue);
EXPORTS WORD  CALLBACK  PCIELM4_WriteAOVoltageH(WORD wBoardNo,WORD wChannel, DWORD dwAOValue);
EXPORTS WORD  CALLBACK  PCIELM4_StartAOVoltageALL(WORD wBoardNo, float fSamplingRate, DWORD dwDataCount,DWORD dwCycleNum, float fValueCH0[], float fValueCH1[]);
EXPORTS WORD  CALLBACK  PCIELM4_StartAOVoltageALLH(WORD wBoardNo, float fSamplingRate, DWORD dwDataCount,DWORD dwCycleNum, DWORD dwValueCH0[], DWORD dwValueCH1[]);
EXPORTS WORD  CALLBACK  PCIELM4_StopAOALL(WORD wBoardNo);

//Analog Input
EXPORTS WORD  CALLBACK  PCIELM4_ConfigAIAutoZero(WORD wBoardNo,WORD wChannel, WORD wEnableAutoZero);
EXPORTS WORD  CALLBACK  PCIELM4_SaveAIAutoZeroVal(WORD wBoardNo, WORD wChannel, DWORD fSamplingRate,DWORD dwAutoZeroValue );
EXPORTS WORD  CALLBACK  PCIELM4_ConfigAI(WORD wBoardNo,WORD wFIFOSizeKB,DWORD BufferSizeCount,WORD wCardType,WORD wDelaySettlingTime,DWORD dwMode);
EXPORTS WORD  CALLBACK  PCIELM4_PollingAI(WORD wBoardNo,WORD wChannel,WORD wConfig, DWORD dwSampleRate, DWORD dwDataCount,double dValue[]);
EXPORTS WORD  CALLBACK  PCIELM4_PollingAIH(WORD wBoardNo,WORD wChannel,WORD wConfig,DWORD dwSampleRate, DWORD dwDataCount,DWORD dwValue[]);
EXPORTS WORD  CALLBACK  PCIELM4_PollingAIHEX(WORD wBoardNo,WORD wChannel,WORD wConfig,DWORD dwSampleRate,DWORD dwDataCount,DWORD dwValue[]);

EXPORTS WORD  CALLBACK  PCIELM4_AIHex2Vol(WORD wBoardNo, WORD wChannel, WORD wConfig,DWORD dwVal, double *dVal);

//Interrupt functions
EXPORTS WORD  CALLBACK  PCIELM4_InstallIrq(WORD wBoardNo,DWORD dwInterruptMask,float fTrgRate);
EXPORTS WORD  CALLBACK  PCIELM4_RemoveIrq(WORD wBoardNo);


#endif